library ieee;
    use ieee.std_logic_1164.all;

library std;
    use std.env.all;

library work;
    use work.test_utility.all;

entity test_DataTypesExample is
    generic( GUI_MODE : boolean; CHECK_RESULTS : boolean );
end entity test_DataTypesExample;

architecture test of test_DataTypesExample is
    signal input_slv       : std_logic_vector(7 downto 0);
    signal output_slv_calc : std_logic_vector(7 downto 0);
    signal output_slv_mask : std_logic_vector(7 downto 0);
    signal output_slv_set  : std_logic_vector(7 downto 0);
begin
    u_DataTypesExample : entity work.DataTypesExample
        port map (
            input_slv       => input_slv,
            output_slv_calc => output_slv_calc,
            output_slv_mask => output_slv_mask,
            output_slv_set  => output_slv_set
        );

    input_slv <= x"5a";

    delay : process
    begin
        wait for 100 ns;
        assert_eq( output_slv_calc, x"52" );
        assert_eq( output_slv_mask, x"5a" );
        assert_eq( output_slv_set, x"7a" );

        if ( GUI_MODE ) then
            std.env.stop;
        else
            std.env.finish;
        end if;
    end process delay;

end architecture test;
